Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/GraphicalSymbolicExpressionTreeView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/GraphicalSymbolicExpressionTreeView.Designer.cs	(revision 15043)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/GraphicalSymbolicExpressionTreeView.Designer.cs	(revision 15044)
@@ -59,5 +59,4 @@
       this.symbolicExpressionTreeChart.Name = "functionTreeChart";
       this.symbolicExpressionTreeChart.Size = new System.Drawing.Size(407, 367);
-      this.symbolicExpressionTreeChart.Spacing = 5;
       this.symbolicExpressionTreeChart.TabIndex = 0;
       this.symbolicExpressionTreeChart.TextFont = new System.Drawing.Font(FontFamily.GenericSerif, 8F);
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionGrammarAllowedChildSymbolsControl.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionGrammarAllowedChildSymbolsControl.Designer.cs	(revision 15043)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionGrammarAllowedChildSymbolsControl.Designer.cs	(revision 15044)
@@ -70,5 +70,4 @@
       this.symbolicExpressionTreeChart.Name = "allowedChildSymbolsControl";
       this.symbolicExpressionTreeChart.Size = new System.Drawing.Size(645, 386);
-      this.symbolicExpressionTreeChart.Spacing = 5;
       this.symbolicExpressionTreeChart.SuspendRepaint = false;
       this.symbolicExpressionTreeChart.TabIndex = 0;
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs	(revision 15043)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs	(revision 15044)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -37,45 +37,8 @@
     private ILayoutEngine<ISymbolicExpressionTreeNode> layoutEngine;
 
-    private int preferredNodeWidth = 70;
-    public int PreferredNodeWidth {
-      get { return preferredNodeWidth; }
-      set { preferredNodeWidth = value; }
-    }
-
-    private int preferredNodeHeight = 46;
-    public int PreferredNodeHeight {
-      get { return preferredNodeHeight; }
-      set { preferredNodeHeight = value; }
-    }
-
-    private int minHorizontalDistance = 30;
-    public int MinimumHorizontalDistance {
-      get { return minHorizontalDistance; }
-      set { minHorizontalDistance = value; }
-    }
-
-    private int minVerticalDistance = 30;
-    public int MinimumVerticalDistance {
-      get { return minVerticalDistance; }
-      set { minVerticalDistance = value; }
-    }
-
-    private int minHorizontalPadding = 20;
-    public int MinimumHorizontalPadding {
-      get { return minHorizontalPadding; }
-      set { minHorizontalPadding = value; }
-    }
-
-    private int minVerticalPadding = 20;
-    public int MinimumVerticalPadding {
-      get { return minVerticalPadding; }
-      set { minVerticalPadding = value; }
-    }
-
     public SymbolicExpressionTreeChart() {
       InitializeComponent();
       this.image = new Bitmap(Width, Height);
       this.stringFormat = new StringFormat { Alignment = StringAlignment.Center, LineAlignment = StringAlignment.Center };
-      this.spacing = 5;
       this.lineColor = Color.Black;
       this.backgroundColor = Color.White;
@@ -86,8 +49,8 @@
 
       layoutEngine = new ReingoldTilfordLayoutEngine<ISymbolicExpressionTreeNode>(n => n.Subtrees) {
-        NodeWidth = preferredNodeWidth,
-        NodeHeight = preferredNodeHeight,
-        HorizontalSpacing = minHorizontalDistance,
-        VerticalSpacing = minVerticalDistance
+        NodeWidth = PreferredNodeWidth,
+        NodeHeight = PreferredNodeHeight,
+        HorizontalSpacing = MinimumHorizontalDistance,
+        VerticalSpacing = MinimumVerticalDistance
       };
       reingoldTilfordToolStripMenuItem.Checked = true;
@@ -100,10 +63,55 @@
 
     #region Public properties
-    private int spacing;
-    public int Spacing {
-      get { return this.spacing; }
-      set {
-        this.spacing = value;
-        this.Repaint();
+    private int preferredNodeWidth = 70;
+    public int PreferredNodeWidth {
+      get { return preferredNodeWidth; }
+      set {
+        preferredNodeWidth = value;
+        Repaint();
+      }
+    }
+
+    private int preferredNodeHeight = 46;
+    public int PreferredNodeHeight {
+      get { return preferredNodeHeight; }
+      set {
+        preferredNodeHeight = value;
+        Repaint();
+      }
+    }
+
+    private int minHorizontalDistance = 30;
+    public int MinimumHorizontalDistance {
+      get { return minHorizontalDistance; }
+      set {
+        minHorizontalDistance = value;
+        Repaint();
+      }
+    }
+
+    private int minVerticalDistance = 30;
+    public int MinimumVerticalDistance {
+      get { return minVerticalDistance; }
+      set {
+        minVerticalDistance = value;
+        Repaint();
+      }
+    }
+
+    private int minHorizontalPadding = 20;
+    public int MinimumHorizontalPadding {
+      get { return minHorizontalPadding; }
+      set {
+        minHorizontalPadding = value;
+        Repaint();
+      }
+    }
+
+    private int minVerticalPadding = 20;
+    public int MinimumVerticalPadding {
+      get { return minVerticalPadding; }
+      set {
+        minVerticalPadding = value;
+        Repaint();
       }
     }
@@ -217,5 +225,5 @@
         graphics.Clear(backgroundColor);
         if (tree != null) {
-          DrawFunctionTree(graphics, preferredNodeWidth, preferredNodeHeight, minHorizontalDistance, minVerticalDistance);
+          DrawFunctionTree(graphics, PreferredNodeWidth, PreferredNodeHeight, MinimumHorizontalDistance, MinimumVerticalDistance);
         }
       }
@@ -318,9 +326,9 @@
         actualRoot = tree.Root.GetSubtree(0);
       }
-      var visualNodes = layoutEngine.CalculateLayout(actualRoot, Width - minHorizontalPadding, Height - minVerticalPadding).ToList();
+      var visualNodes = layoutEngine.CalculateLayout(actualRoot, Width - MinimumHorizontalPadding, Height - MinimumVerticalPadding).ToList();
       // add the padding
       foreach (var vn in visualNodes) {
-        vn.X += minHorizontalPadding / 2;
-        vn.Y += minVerticalPadding / 2;
+        vn.X += MinimumHorizontalPadding / 2;
+        vn.Y += MinimumVerticalPadding / 2;
       }
 
@@ -408,5 +416,5 @@
       Image image = new Bitmap(Width, Height);
       using (Graphics g = Graphics.FromImage(image)) {
-        DrawFunctionTree(g, preferredNodeWidth, preferredNodeHeight, minHorizontalDistance, minVerticalDistance, false);
+        DrawFunctionTree(g, PreferredNodeWidth, PreferredNodeHeight, MinimumHorizontalDistance, MinimumVerticalDistance, false);
       }
       image.Save(filename);
@@ -418,5 +426,5 @@
         using (Metafile file = new Metafile(filename, g.GetHdc())) {
           using (Graphics emfFile = Graphics.FromImage(file)) {
-            DrawFunctionTree(emfFile, preferredNodeWidth, preferredNodeHeight, minHorizontalDistance, minVerticalDistance, false);
+            DrawFunctionTree(emfFile, PreferredNodeWidth, PreferredNodeHeight, MinimumHorizontalDistance, MinimumVerticalDistance, false);
           }
         }
@@ -439,11 +447,9 @@
 
     private void reingoldTilfordToolStripMenuItem_Click(object sender, EventArgs e) {
-      minHorizontalDistance = 30;
-      minVerticalDistance = 30;
       layoutEngine = new ReingoldTilfordLayoutEngine<ISymbolicExpressionTreeNode>(n => n.Subtrees) {
-        NodeWidth = preferredNodeWidth,
-        NodeHeight = preferredNodeHeight,
-        HorizontalSpacing = minHorizontalDistance,
-        VerticalSpacing = minVerticalDistance
+        NodeWidth = PreferredNodeWidth,
+        NodeHeight = PreferredNodeHeight,
+        HorizontalSpacing = MinimumHorizontalDistance,
+        VerticalSpacing = MinimumVerticalDistance
       };
       reingoldTilfordToolStripMenuItem.Checked = true;
@@ -453,11 +459,9 @@
 
     private void boxesToolStripMenuItem_Click(object sender, EventArgs e) {
-      minHorizontalDistance = 5;
-      minVerticalDistance = 5;
       layoutEngine = new BoxesLayoutEngine<ISymbolicExpressionTreeNode>(n => n.Subtrees, n => n.GetLength(), n => n.GetDepth()) {
-        NodeWidth = preferredNodeWidth,
-        NodeHeight = preferredNodeHeight,
-        HorizontalSpacing = minHorizontalDistance,
-        VerticalSpacing = minVerticalDistance
+        NodeWidth = PreferredNodeWidth,
+        NodeHeight = PreferredNodeHeight,
+        HorizontalSpacing = MinimumHorizontalDistance,
+        VerticalSpacing = MinimumVerticalDistance
       };
       reingoldTilfordToolStripMenuItem.Checked = false;
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.Designer.cs	(revision 15043)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.Designer.cs	(revision 15044)
@@ -187,5 +187,4 @@
       this.treeChart.Name = "treeChart";
       this.treeChart.Size = new System.Drawing.Size(201, 348);
-      this.treeChart.Spacing = 5;
       this.treeChart.SuspendRepaint = false;
       this.treeChart.TabIndex = 0;